import os
from gym import utils
from gym.envs.robotics import fetch_env_robot


# Ensure we get the path separator correct on windows
MODEL_XML_PATH = os.path.join('fetch', 'robotic_rope.xml')


class RoboticRopeEnv(fetch_env_robot.FetchEnv, utils.EzPickle):
    def __init__(self, reward_type='dense'):
        initial_qpos = {
            'robot0:slide0': 0.4049,
            'robot0:slide1': 0.48,
            'robot0:slide2': 0.0,
        }
        fetch_env_robot.FetchEnv.__init__(
            self, MODEL_XML_PATH, has_object=False, block_gripper=True, n_substeps=20,
            gripper_extra_height=0.2, target_in_the_air=True, target_offset=0.0,
            obj_range=0.2, target_range=0.2, distance_threshold=0.15,
            initial_qpos=initial_qpos, reward_type=reward_type, image_obs=False, random_maze=True)
        utils.EzPickle.__init__(self)
